import tkinter
import tkinter.simpledialog as simpledialog
import tkinter.messagebox as messagebox
import tkinter.filedialog as filedialog
import tkinter.ttk
import os
import os.path

import netzjargon
import autostart
import add_on
import webbrowser

codemodul_list = add_on.search_moduls('Codes')

codes = []
codemodul = {}
for i in codemodul_list:
    modulname = os.path.splitext(i)[0]
    importstring = 'import Codes. %s' % modulname
    exec(importstring)
    codes.append(modulname)
    exec('codemodul[\''+modulname+'\'] = Codes.'+modulname)

def infocus(var):
    window.wm_attributes('-alpha', 0.9)

def outfocus(var):
    window.wm_attributes('-alpha', 0.5)

def hidewindow(var):
    windowposition = window.geometry()
    window.geometry('+-600+-600')
    window.after(5000, window.geometry, (windowposition))

def longerhidewindow(var):
    windowposition = window.geometry()
    window.geometry('+-600+-600')
    window.after(30000, window.geometry, (windowposition))
    
border = False
def border_on_off():
    global border
    bool_swich = {True: False, False: True}
    window.overrideredirect(bool_swich[border])
    border = bool_swich[border]

window = tkinter.Tk()
window.geometry('+0+0')
window.wm_attributes('-topmost', True, '-alpha', 0.9)   #Fenster immer in den Vordergrund setzen und 0.9 Transparenz
window.resizable(0, 0)
window.title('ChatCrack')

window.bind('<FocusIn>', infocus)
window.bind('<FocusOut>', outfocus)
window.bind('<Button-2>', longerhidewindow)
window.bind('<Button-3>', hidewindow)

def en_decode():
    try:
        if textvar.get():
            text.delete(1.0, 'end')
            if codemodul[codevar.get()].needs_pass:
                text.insert(1.0, codemodul[codevar.get()].decode(encodetext.get(1.0, 'end'), simpledialog.askstring('Passwort abfrage',
                                                                                                                'Bitte Passwort eingeben:', show='*')))
            else:
                text.insert(1.0, codemodul[codevar.get()].decode(encodetext.get(1.0, 'end')))
        else:
            encodetext.delete(1.0, 'end')
            if codemodul[codevar.get()].needs_pass:
                encodetext.insert(1.0, codemodul[codevar.get()].encode(text.get(1.0, 'end'), simpledialog.askstring('Passwort abfrage',
                                                                                                               'Bitte Passwort eingeben:', show='*')))
            else:
                encodetext.insert(1.0, codemodul[codevar.get()].encode(text.get(1.0, 'end')))            
    except:
        messagebox.showerror('Fehler', 'Der Text konnte nicht entschlüsselt werden.')        

def fileopen():              #Funktionen für Dateimenü
    try:
        path = filedialog.askopenfilename()
        with open(path, 'r') as file:
            if textvar.get():
                text.delete(1.0, 'end')
                text.insert(1.0, file.read())
            else:
                encodetext.delete(1.0, 'end')
                encodetext.insert(1.0, file.read())
    except IOError:
        messagebox.showerror('Fehler', 'Datei konnte nicht geöffnet werden.')

def filesave():
    try:
        path = filedialog.asksaveasfilename()
        with open(path, 'w') as file:
            if textvar.get():
                file.write(text.get(1.0, 'end'))
            else:
                file.write(encodetext.get(1.0, 'end'))
    except IOError:
        messagebox.showerror('Fehler', 'Datei konnte nicht gespeichert werden.')

def text_replace():           #Funktionen für Textmenü
    oldchar = simpledialog.askstring('Ersetzten', 'Altes Zeichen:')
    newchar = simpledialog.askstring('Ersetzten', 'Neues Zeichen:')
    if textvar.get():
        textcopy = text.get(1.0, 'end')
        text.delete(1.0, 'end')
        text.insert(1.0, textcopy.replace(oldchar, newchar))
    else:
        textcopy = encodetext.get(1.0, 'end')
        encodetext.delete(1.0, 'end')
        encodetext.insert(1.0, textcopy.replace(oldchar, newchar))

def text_delete():
    if textvar.get():
        text.delete(1.0, 'end')
    else:
        encodetext.delete(1.0, 'end')

def text_move():
    if textvar.get():
        encodetext.delete(1.0, 'end')
        encodetext.insert(1.0, text.get(1.0, 'end'))
    else:
        text.delete(1.0, 'end')
        text.insert(1.0, encodetext.get(1.0, 'end'))

def webtranslate():
    if textvar.get():
        webbrowser.open('http://translate.google.de/?hl=de&tab=wT#en|de|'+text.get(1.0, 'end'))
    else:
        webbrowser.open('http://translate.google.de/?hl=de&tab=wT#en|de|'+encodetext.get(1.0, 'end'))

#Menüanfang
menubar = tkinter.Menu(window)
filemenu = tkinter.Menu(menubar)
filemenu.add_command(label='Datei öffnen', command=fileopen)
filemenu.add_command(label='Datei speichern', command=filesave)
filemenu.add_separator()
filemenu.add_command(label='Beenden', command=exit)

netzjargonmenu = tkinter.Menu(menubar)
netzjargonmenu.add_command(label='Netzjargon übersetzter', command=netzjargon.netzjargon_window)
netzjargonmenu.add_command(label='Abkürzung hinzufügen', command=netzjargon.new_abbreviation_window)

textmenu = tkinter.Menu(menubar)
textmenu.add_command(label='Ersetzten', command=text_replace)
textmenu.add_command(label='Löschen', command=text_delete)
textmenu.add_command(label='Verschieben', command=text_move)
textmenu.add_command(label='Übersetzten', command=webtranslate)

extramenu = tkinter.Menu(menubar)
extramenu.add_command(label='Autostart Manager', command=autostart.config_autostart)
extramenu.add_command(label='Rand', command=border_on_off)

menubar.add_cascade(label='Datei', menu=filemenu)
menubar.add_cascade(label='Text', menu=textmenu)
menubar.add_cascade(label='Netzjargon', menu=netzjargonmenu)
menubar.add_cascade(label='Extras', menu=extramenu)
#Menüende

codevar = tkinter.StringVar()
code = tkinter.ttk.Combobox(window, textvariable=codevar, state='readonly')
code['values'] = codes
code.grid(row=0, column=0)

textvar = tkinter.BooleanVar()
textradiobutton=tkinter.Radiobutton(window, text='Klartext', variable=textvar, value=True)
textradiobutton.grid(row=0, column=0, sticky='w')
text = tkinter.Text(window, height=5, width=65, wrap='word')
text.grid(row=1, column=0)
encodetextradiobutton = tkinter.Radiobutton(window, text='Kodiertertext', variable=textvar, value=False)
encodetextradiobutton.grid(row=2, column=0, sticky='w')
tkinter.Button(window, text='Codieren', command=en_decode).grid(row=2, column=0)
encodetext = tkinter.Text(window, height=5, width=65, wrap='word')
encodetext.grid(row=3, column=0)

window.config(menu=menubar)

tkinter.mainloop()
