import tkinter
import tkinter.messagebox as messagebox
import tkinter.simpledialog as simpledialog
import pickle
import webbrowser
import subprocess

try:
    with open('websites.obj', 'rb') as websitefile:           #öffnet alle websiten
        websites = pickle.load(websitefile)
except IOError:
    messagebox.showerror('Fehler', 'Die Datei: websites.obj ist nicht vorhanden.')
    websites=[] #Das Programm kann normal weiterlaufen
    
try:
    with open('chatprogramms.obj', 'rb') as chatprogfile:       #öffnet alle Chatprogramme
        chatprogs = pickle.load(chatprogfile)
except IOError:
    messagebox.showerror('Fehler', 'Die Datei: chatprogramms.obj ist nicht vorhanden.')
    chatprogs={} #Das Programm kann normal weiterlaufen

for website in websites:
    webbrowser.open(website)
    
for prog in chatprogs:
    try:
        subprocess.Popen(chatprogs[prog], executable=prog)
    except:
        messagebox.showerror('Fehler', 'Das Programm %s konnte nicht gestarted werden.' % prog)

def config_autostart():
    def delete_website():
        if messagebox.askyesno('Löschen', 'Webdienst wircklich löschen?'):
            try:
                websiteindex = int(websites_listbox.curselection()[0])
                websites.remove(websites_listbox.get(websiteindex))
                websites_listbox.delete(websiteindex)
                with open('websites.obj', 'wb') as websitefile:
                    pickle.dump(websites, websitefile)                        
            except IndexError:
                messagebox.showerror('Fehler', 'Der Webdienst kann nicht gelöscht werden.')
            except IOError:
                messagebox.showerror('Fehler', 'Die Datei: websites.obj ist nicht vorhanden.')

    def edit_website():
        new_website = simpledialog.askstring('Webdienst Bearbeiten', 'Bitte die neue URL eingeben:')
        try:
            websiteindex = int(websites_listbox.curselection()[0])
            websites.remove(websites_listbox.get(websiteindex))
            websites.append(new_website)
            websites_listbox.delete(websiteindex)
            websites_listbox.insert('end', new_website)
            with open('websites.obj', 'wb') as websitefile:
                pickle.dump(websites, websitefile)
        except IndexError:
            messagebox.showerror('Fehler', 'Die Änderung kann nicht gespeichert werden')
        except IOError:
            messagebox.showerror('Fehler', 'Die Datei: websites.obj ist nicht vorhanden.')

    def add_website():
        website = simpledialog.askstring('Webdienst Hinzufügen', 'Bitte die URL des Webdienstes eingeben:')
        websites_listbox.insert('end', website)
        websites.append(website)
        try:
            with open('websites.obj', 'wb') as websitefile:
                pickle.dump(websites, websitefile)
        except IOError:
            messagebox.showerror('Fehler', 'Die Datei: websites.obj ist nicht vorhanden.')

    def delete_chatprog():
        if messagebox.askyesno('Löschen', 'Chatprogramm wircklich löschen?'):
            try:
                chatprogindex = int(chatprogs_listbox.curselection()[0])
                del chatprogs[chatprogs_listbox.get(chatprogindex)]
                chatprogs_listbox.delete(chatprogindex)
                with open('chatprogramms.obj', 'wb') as chatprogfile:
                    pickle.dump(chatprogs, chatprogfile)
            except IndexError:
                messagebox.showerror('Fehler', 'Die Änderung kann nicht gespeichert werden')
            except IOError:
                messagebox.showerror('Fehler', 'Die Datei: chatprogramms.obj ist nicht vorhanden.')

    def edit_chatprog():
        def save():
            try:
                chatprogindex = int(chatprogs_listbox.curselection()[0])
                del chatprogs[chatprogs_listbox.get(chatprogindex)]
                chatprogs_listbox.delete(0, 'end')         #Inhalt der Listbox löschen
                chatprogs[path_entry.get()] = parameter_entry.get()
                for prog in chatprogs:
                    chatprogs_listbox.insert('end', prog)
                with open('chatprogramms.obj', 'wb') as chatprogfile:
                    pickle.dump(chatprogs, chatprogfile)
            except IndexError:
                messagebox.showerror('Fehler', 'Die Änderung kann nicht gespeichert werden')
            except IOError:
                messagebox.showerror('Fehler', 'Die Datei: chatprogramms.obj ist nicht vorhanden.')
        chatprog_edit_window = tkinter.Toplevel()
        chatprog_edit_window.title('Chatprogram Bearbeiten')

        tkinter.Label(chatprog_edit_window, text='Pfad: ').grid(row=0, column=0, sticky='w')
        path_entry = tkinter.Entry(chatprog_edit_window, width=70)
        path_entry.grid(row=0, column=1)
        tkinter.Label(chatprog_edit_window, text='Parameter: ').grid(row=1, column=0, sticky='w')
        parameter_entry = tkinter.Entry(chatprog_edit_window, width=70)
        parameter_entry.grid(row=1, column=1)
        tkinter.Button(chatprog_edit_window, text='Speichern', command=save).grid(row=2, column=1)

    def add_chatprog():
        def save():
            try:
                chatprogs[path_entry.get()] = parameter_entry.get()
                chatprogs_listbox.insert('end', path_entry.get())
                with open('chatprogramms.obj', 'wb') as chatprogfile:
                    pickle.dump(chatprogs, chatprogfile)
            except IndexError:
                messagebox.showerror('Fehler', 'Die Änderung kann nicht gespeichert werden')
            except IOError:
                messagebox.showerror('Fehler', 'Die Datei: chatprogramms.obj ist nicht vorhanden.')
                
        chatprog_add_window = tkinter.Toplevel()
        chatprog_add_window.title('Chatprogramm Hinzufügen')

        tkinter.Label(chatprog_add_window, text='Pfad: ').grid(row=0, column=0, sticky='w')
        path_entry = tkinter.Entry(chatprog_add_window, width=70)
        path_entry.grid(row=0, column=1)
        tkinter.Label(chatprog_add_window, text='Parameter: ').grid(row=1, column=0, sticky='w')
        parameter_entry = tkinter.Entry(chatprog_add_window, width=70)
        parameter_entry.grid(row=1, column=1)
        tkinter.Button(chatprog_add_window, text='Speichern', command=save).grid(row=2, column=1)
                
    config_window = tkinter.Toplevel()
    config_window.title('Autostart Configuration')

    tkinter.Label(config_window, text='Webdienste:').grid(row=0, column=0, sticky='w')
    websites_listbox = tkinter.Listbox(config_window, width=50, height=5)
    websites_listbox.grid(row=1, column=0)
    
    for website in websites:
        websites_listbox.insert('end', website)

    tkinter.Label(config_window, text='Chatprogramme:').grid(row=2, column=0, sticky='w')
    chatprogs_listbox = tkinter.Listbox(config_window, width=50, height=5)
    chatprogs_listbox.grid(row=3, column=0)

    for prog in chatprogs:
        chatprogs_listbox.insert('end', prog)
        
    website_deletebutton = tkinter.Button(config_window, text='Löschen', command=delete_website)
    website_deletebutton.grid(row=1, column=1, sticky='n')
    website_configbutton = tkinter.Button(config_window, text='Bearbeiten', command=edit_website)
    website_configbutton.grid(row=1, column=1)
    website_addbutton = tkinter.Button(config_window, text='Hinzufügen', command=add_website)
    website_addbutton.grid(row=1, column=1, sticky='s')

    chatprogs_deletebutton = tkinter.Button(config_window, text='Löschen', command=delete_chatprog)
    chatprogs_deletebutton.grid(row=3, column=1, sticky='n')
    chatprogs_configbutton = tkinter.Button(config_window, text='Bearbeiten', command=edit_chatprog)
    chatprogs_configbutton.grid(row=3, column=1)
    chatprogs_addbutton = tkinter.Button(config_window, text='Hinzufügen', command=add_chatprog)
    chatprogs_addbutton.grid(row=3, column=1, sticky='s')
    
if __name__ == '__main__':
    helpwindow = tkinter.Tk()
    config_autostart()
    tkinter.mainloop()

