import pickle
import tkinter
import sys
import webbrowser

with open('netzjargon.obj', 'rb') as netzjargonfile:
    netzjargon_dict = pickle.load(netzjargonfile)


def add_new_abbreviation(abbreviation, english, german):
    'Fügt eine neue abkürzung hinzu oder ändert eine alte.'
    netzjargon_dict[abbreviation.upper()] = (english, german)
    with open('netzjargon.obj', 'wb') as netzjargonfile:
        pickle.dump(netzjargon_dict, netzjargonfile)

def delete_abbreviation(abbreviation):
    'Löscht eine alte abkürzung.'
    try:
        del netzjargon_dict[abbreviation.upper()]
    except KeyError:
        pass           #falls die abkürzung nicht existiert
    with open('netzjargon.obj', 'wb') as netzjargonfile:
        pickle.dump(netzjargon_dict, netzjargonfile)

def netzjargon_window():
    def search():
        try:
            translation = netzjargon_dict[abbreviation_entry.get().upper()]
            english_meaning_label.config(text=translation[0])
            german_meaning_label.config(text=translation[1])
        except KeyError:
            webbrowser.open('http://www.google.de/search?hl=de&q='+abbreviation_entry.get())   #websuche starten
            
    netzjargon_window = tkinter.Toplevel()
    netzjargon_window.title('Netzjargon  -  übersetzter')
    tkinter.Label(netzjargon_window, text='Abkürzung: ').grid(row=0, column=0)
    abbreviation_entry = tkinter.Entry(netzjargon_window, width=10)
    abbreviation_entry.grid(row=0, column=1)
    
    tkinter.Button(netzjargon_window, text='Suchen', command=search).grid(row=0, column=2)
    tkinter.Label(netzjargon_window, text='Englische bedeutung:').grid(row=1, column=0)
    tkinter.Label(netzjargon_window, text='Deutsche bedeutung:').grid(row=1, column=2)
    
    english_meaning_label = tkinter.Label(netzjargon_window)
    english_meaning_label.grid(row=2, column=0)
    german_meaning_label = tkinter.Label(netzjargon_window)
    german_meaning_label.grid(row=2, column=2)

def new_abbreviation_window():
    def save_changes():
        add_new_abbreviation(abbreviation_entry.get().upper(), english_meaning_entry.get(), german_meaning_entry.get())
        
    def delete():
        delete_abbreviation(abbreviation_entry.get())
        
    new_abbreviation_window=tkinter.Toplevel()
    new_abbreviation_window.title('Netzjargon - abkürzung hinzufügen, ändern oder löschen')
    tkinter.Label(new_abbreviation_window, text='Abkürzung: ').grid(row=0, column=0)
    abbreviation_entry=tkinter.Entry(new_abbreviation_window, width=10)
    abbreviation_entry.grid(row=0, column=1)
    
    tkinter.Label(new_abbreviation_window, text='Englische bedeutung: ').grid(row=1, column=0)
    english_meaning_entry=tkinter.Entry(new_abbreviation_window, width=50)
    english_meaning_entry.grid(row=1, column=1)
    tkinter.Label(new_abbreviation_window, text='Deutsche bedeutung: ').grid(row=2, column=0)
    
    german_meaning_entry=tkinter.Entry(new_abbreviation_window, width=50)
    german_meaning_entry.grid(row=2, column=1)
    tkinter.Button(new_abbreviation_window, text='Hinzufügen', command=save_changes).grid(row=3, column=0)
    tkinter.Button(new_abbreviation_window, text='Löschen', command=delete).grid(row=3, column=1)
